/*
* ===========================================
* Java Pdf Extraction Decoding Access Library
* ===========================================
*
* Project Info:  http://www.jpedal.org
* Project Lead:  Mark Stephens (mark@idrsolutions.com)
*
* (C) Copyright 2003, IDRsolutions and Contributors.
*
* 	This file is part of JPedal
*
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


*
* ---------------
* DeviceNColorSpace.java
* ---------------
* (C) Copyright 2003, by IDRsolutions and Contributors.
*
* Original Author:  Mark Stephens (mark@idrsolutions.com)
* Contributor(s):
*
*
*/
package org.jpedal.color;

import java.util.Map;
import org.jpedal.io.PdfObjectReader;

/**
 * handle Device ColorSpace
 */
public class DeviceNColorSpace
	extends SeparationColorSpace {
	
	public DeviceNColorSpace(){	
		
	}
	
	public DeviceNColorSpace(PdfObjectReader currentPdfFile,String currentColorspace,Map colorValues) {

		value = ColorSpaces.DeviceN;
		
		processColorToken(currentPdfFile, currentColorspace, colorValues);
	}
	
	//<start-13>
	/** set color (translate and set in alt colorspace */
	public void setColor(String[] operand,int opCount) {

		try{
			
			float[] values = new float[opCount];
			for(int j=0;j<opCount;j++)
			values[j] = Float.parseFloat(operand[j]);
			
			operand =colorMapper.getOperand(values);
		
			altCS.setColor(operand,operand.length);
		
		}catch(Exception e){
		}

	}
	//<end-13>
	
}
