/*
* ===========================================
* Java Pdf Extraction Decoding Access Library
* ===========================================
*
* Project Info:  http://www.jpedal.org
* Project Lead:  Mark Stephens (mark@idrsolutions.com)
*
* (C) Copyright 2004, IDRsolutions and Contributors.
*
* 	This file is part of JPedal
*
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


*
* ---------------
* Name.java
* ---------------
* (C) Copyright 2004, by IDRsolutions and Contributors.
*
* Original Author:  Mark Stephens (mark@idrsolutions.com)
* Contributor(s):
*
*/
package org.jpedal.fonts.tt;

public class Name extends Table {
	
	/**max number of glyphs*/
	private int encoding=0;
	
	public Name(FontFile2 currentFontFile){
	
		//LogWriter.writeMethod("{readMapxTable}", 0);
		
		//move to start and check exists
		int startPointer=currentFontFile.selectTable(FontFile2.NAME);
		
		//read 'head' table
		if(startPointer!=0){
			
			int format=currentFontFile.getNextUint16();
			int count=currentFontFile.getNextUint16();
			int offset=currentFontFile.getNextUint16();
			System.out.println(format);
			for(int i=0;i<count;i++){
				System.out.println("====");
				int platformID=currentFontFile.getNextUint16();
				int platformSpecificID=currentFontFile.getNextUint16();
				int langID=currentFontFile.getNextUint16();
				int nameID=currentFontFile.getNextUint16();
				int length=currentFontFile.getNextUint16();
				int offset2=currentFontFile.getNextUint16();
				
				System.out.println(platformID+" "+platformSpecificID+" "+langID);
			}
		}
	}
	
	public int getEncoding(){
		return encoding;
	}
}
