/*
* ===========================================
* Java Pdf Extraction Decoding Access Library
* ===========================================
*
* Project Info:  http://www.jpedal.org
* Project Lead:  Mark Stephens (mark@idrsolutions.com)
*
* (C) Copyright 2003, IDRsolutions and Contributors.
*
* 	This file is part of JPedal
*
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


*
* ---------------
* JAIHelper.java
* ---------------
* (C) Copyright 2006, by IDRsolutions and Contributors.
*
* Original Author:  Mark Stephens (mark@idrsolutions.com)
* Contributor(s):
*
*/
package org.jpedal.io;

import java.io.IOException;

import javax.swing.JEditorPane;
import javax.swing.JOptionPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;

import org.jpedal.PdfDecoder;
import org.jpedal.utils.BrowserLauncher;
import org.jpedal.utils.Messages;

public class JAIHelper {

	private static boolean JAI_TESTED;
	
	public static void confirmJAIOnClasspath() {
	
		if(JAI_TESTED)
			return;
	
		JAIHelper.JAI_TESTED = true;
		
		//test
		if(PdfDecoder.showErrorMessages){
			
			try {
				Class.forName("javax.media.jai.JAI");
			} catch (ClassNotFoundException e) {
				JEditorPane p = new JEditorPane(
						"text/html",
						Messages.getMessage("PdfViewer.JAINotOnClasspathWarning")
						+ Messages.getMessage("PdfViewer.JAINotOnClasspathWarning1")
						+ Messages.getMessage("PdfViewer.JAINotOnClasspathWarning2"));
				p.setEditable(false);
				p.setOpaque(false);
				p.addHyperlinkListener( new HyperlinkListener() {
					public void hyperlinkUpdate(HyperlinkEvent e) {
						if (e.getEventType().equals(HyperlinkEvent.EventType.ACTIVATED)) {
							try {
								BrowserLauncher.openURL("http://java.sun.com/products/java-media/jai/current.html");
							} catch (IOException e1) {
								JOptionPane.showMessageDialog(null,Messages.getMessage("PdfViewer.ErrorWebsite"));
							}
						}
					}
				});
				
				//<sxtart-13>
				//JFrame f = new JFrame();
				//f.setLocationRelativeTo(null);
				//f.setVisible(true);
				JOptionPane.showMessageDialog(null,p);
				//f.setVisible(false);
				
				/**
				//<xend-13>
				JOptionPane optionPane = new JOptionPane();
				optionPane.setMessage(p);
				optionPane.setMessageType(JOptionPane.INFORMATION_MESSAGE);
				optionPane.setOptionType(JOptionPane.DEFAULT_OPTION);
				
				JDialog dialog = optionPane.createDialog(null, "iText");
				dialog.pack();
				dialog.setSize(400,200);
				dialog.show(); 
				/**/
				
			} 
		}
	}

}
